var TMP_SONOS_QUEUE_NAME = "dSS-tmp";

var lPerf = {
	logln : function(o) {
	}
};

lPerf = new Logger("sonos-controller-perf.log");

function signalDisabledPlayer(ip) {
	lWarn.logln('Player with ip ' + ip + ' is not reachable');
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
		if (oPlayerArray[jIndex].getChild('ip')!=null)
			if (oPlayerArray[jIndex].getChild('ip').getValue()==ip) {
				oPlayerArray[jIndex].getChild('online').setValue(false);
				new Event('sonos.player',{actions:'searchAfterLostPlayer',time:'+30'}).raise();
			} 
	}
}

function isIPOnline(ip) {
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
		if (oPlayerArray[jIndex].getChild('ip')!=null)
			if (oPlayerArray[jIndex].getChild('ip').getValue()==ip)
				if (oPlayerArray[jIndex].getChild('online')!=null) 
					if (oPlayerArray[jIndex].getChild('online').getValue()==true)
						return true;
	}
	return false;
}

function isIPOnlineAndCoordinator(ip) {
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
		if (oPlayerArray[jIndex].getChild('ip')!=null)
			if (oPlayerArray[jIndex].getChild('ip').getValue()==ip)
				if (oPlayerArray[jIndex].getChild('online')!=null) 
					if (oPlayerArray[jIndex].getChild('online').getValue()==true)
						//if (oPlayerArray[jIndex].getChild('coordinator')!=null) 
							//if (oPlayerArray[jIndex].getChild('coordinator').getValue()==true)
								return true;
	}
	return false;
}

function timeFromDuration(sText) {
	var oText=sText.split(':');
	return parseInt(oText[0],10)*60*60 + parseInt(oText[1],10)*60 + parseInt(oText[2],10); 
}

function encodeMetaDataUpnp(metaData) {	
	metaData=metaData.replace(/&/g, '&amp;');
	metaData=metaData.replace(/</g, '&lt;');
	metaData=metaData.replace(/>/g, '&gt;');
	metaData=metaData.replace(/"/g, '&quot;');
	metaData=metaData.replace(/'/g, '&apos;');
	return metaData;
}


function htmlUnescape(str)
{
  if (typeof(str) === "string")
    return str.replace(/&amp;/g, '&').replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&apos;/g, "'").replace(/&#039;/g, '\'').replace(/&apos;/g, "'");
  else
    return str;
}

function cleanXMLText(sXML) {
  return sXML.replace(/&(lt|gt|quot|amp;apos);/g, function(m, t) {
                            switch (t) {
                              case 'lt':
                                return '<';
                              case 'gt':
                                return '>';
                              case 'quot':   
                                return '\"';
                              case 'amp;apos':
                                return "\'";
                              default:
                               return "";
                            }
                         }); 
} 

function unescapeXML(sText) {
	return sText.replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, '"').replace(/&apos;/g, "'").replace(/&#039;/g, "'");
}

function getXMLItem(xmlData,tagName) {
	var sEnd = '</' + tagName + ">"
    
	var start_pos = xmlData.indexOf("<" + tagName + " ");    
    var start_pos1 = xmlData.indexOf("<" + tagName + ">");
    if (start_pos<0)
    	start_pos=start_pos1;
    else {
    	if (start_pos1>=0) {
    		if (start_pos1<start_pos)
    			start_pos=start_pos1;
    	}
    }
    
    var end_pos = xmlData.indexOf(sEnd);
    xmlData=xmlData.substring(start_pos, end_pos); 
    return xmlData.substring(xmlData.indexOf('>')+1);    
}

function getXMLAttribute(xmlData,tagName,attributeName) {
    var start_pos = xmlData.indexOf("<" + tagName + " ");    
    var start_pos1 = xmlData.indexOf("<" + tagName + ">");
    if (start_pos<0)
    	start_pos=start_pos1;
    else {
    	if (start_pos1>=0) {
    		if (start_pos1<start_pos)
    			start_pos=start_pos1;
    	}
    }
    
    if (start_pos<0)
    	return "";
    xmlData=xmlData.substring(start_pos);
    xmlData=xmlData.substring(0,xmlData.indexOf(">"));
    if (xmlData.indexOf(attributeName+'="')<0)
      return "";
    start_pos=xmlData.indexOf(attributeName+'="')+attributeName.length+2;
    xmlData=xmlData.substring(start_pos);
    xmlData=xmlData.substring(0,xmlData.indexOf('"'));
    
    return xmlData;    
}

function findStartTagPosition(xmlData, tagName, offset) {

	var start_pos = xmlData.substring(offset).indexOf("<" + tagName + " ");    
    var start_pos1 = xmlData.substring(offset).indexOf("<" + tagName + ">");
    if (start_pos<0)
    	start_pos=start_pos1;
    else {
    	if (start_pos1>=0) {
    		if (start_pos1<start_pos)
    			start_pos=start_pos1;
    	}
    }
    if (start_pos==-1)
    	return -1;
    return start_pos+offset;
}

function findEndTagPosition(xmlData, tagName, offset) {

	var sEnd = '</' + tagName + ">"
	var end_pos = -1;
    if (xmlData.indexOf(sEnd)==-1)
    	end_pos= xmlData.substring(offset).indexOf('/>') + 2;
    else
    	end_pos = xmlData.substring(offset).indexOf(sEnd) + sEnd.length;
    
    if (end_pos==-1)
    	return -1;
    return end_pos+offset;	
}

function findOneTag(xmlData,tagName,offset) {
	var startPos=findStartTagPosition(xmlData,tagName,offset);
    if (startPos==-1)
    	return {start:-1,end:-1};
	var subItemOffset=startPos;
	do {
		var endPos=findEndTagPosition(xmlData,tagName,subItemOffset);
		if (endPos==-1)
	    	return {start:-1,end:-1};
		var possibleInteralStart=findStartTagPosition(xmlData,tagName,subItemOffset + tagName.length+1 );
		if (possibleInteralStart==-1)
			break;
		if (possibleInteralStart>=endPos)
			break;
		var subPos=findOneTag(xmlData,tagName,possibleInteralStart);
		subItemOffset=subPos.end;
	} while(true);
	
	return {start:startPos,end:endPos};
}

function getXMLItemData(xmlData, tagName) {
  
    var returnValues = [];
    do
    {        
    	var erg=findOneTag(xmlData,tagName,0);
    	if (erg.start==-1)
    		break;
    	var searched_value = xmlData.substring(erg.start, erg.end);
        
        if (searched_value.length > 0)
          returnValues.push(searched_value);
          
        xmlData = xmlData.substring(erg.end);
    }
    while (xmlData != '')
    
    return returnValues;
}

var SOAPBodyStart =
	'<?xml version="1.0" encoding="utf-8"?>' + 
	'<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">' +
		'<s:Body>';
var SOAPBodyEnd =
	    '</s:Body>' + 
     '</s:Envelope>';

function upnpPlay(szIpAddressRenderer) {
	try {
		lInfo.logln('play ' + szIpAddressRenderer);
		if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
			return;
		var oStartDate=new Date().getTime();
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Play"';

		var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		var action = '<u:Play xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
				     	'<InstanceID>0</InstanceID>' + 
				     	'<Speed>1</Speed>' + 
				     '</u:Play>'; 
		
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else
			if (result.body != null)
				lInfo.logln(result.body);
		lPerf.logln('runtime upnpPlay '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpPlay command " + e);
	}
}

function upnpPause(szIpAddressRenderer) {
	try {
		if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
			return;
		var oStartDate=new Date().getTime();
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPAction:"urn:schemas-upnp-org:service:AVTransport:1#Pause"';

		var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		var action = '<u:Pause xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
		                 '<InstanceID>0</InstanceID>' + 
		             '</u:Pause>';

		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		
		lPerf.logln('runtime upnpPause '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpStop command " + e);
	}
}

function upnpPrev(szIpAddressRenderer) {
	try {
		if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
			return;
		var oStartDate=new Date().getTime();
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPAction:"urn:schemas-upnp-org:service:AVTransport:1#Previous"';

		var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		var action = '<u:Previous xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
		                '<InstanceID>0</InstanceID>' + 
		             '</u:Previous>';
		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

		lPerf.logln('runtime upnpStop '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpStop command " + e);
	}
}

function upnpNext(szIpAddressRenderer) {
	try {
		if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
			return;
		var oStartDate=new Date().getTime();
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPAction:"urn:schemas-upnp-org:service:AVTransport:1#Next"';

		var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		var action = '<u:Next xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
		                '<InstanceID>0</InstanceID>' + 
		             '</u:Next>';
		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

		lPerf.logln('runtime upnpStop '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpStop command " + e);
	}
}

function upnpStop(szIpAddressRenderer) {
	try {
		if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
			return;
		lInfo.logln('huhu ' + szIpAddressRenderer);
		var oStartDate=new Date().getTime();
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPAction:"urn:schemas-upnp-org:service:AVTransport:1#Stop"';

		var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		var action = '<u:Stop xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
		                '<InstanceID>0</InstanceID>' + 
		             '</u:Stop>';
		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else
			lInfo.logln(result.body)
		lPerf.logln('runtime upnpStop '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpStop command " + e);
	}
}


function upnpGetSonosFavorites(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	
	var oStartDate=new Date().getTime();
	var http_headers = [];
	http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
	http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"';

	var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);

	try {

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaServer/ContentDirectory/Control';
		lInfo.logln("URL " + url);

		var action = '<u:Browse xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">' + 
		                  '<ObjectID>FV:2</ObjectID>' + 
		                  '<BrowseFlag>BrowseDirectChildren</BrowseFlag>' + 
		                  '<Filter />' + 
		                  '<StartingIndex>0</StartingIndex>' + 
		                  '<RequestedCount>0</RequestedCount>' + 
		                  '<SortCriteria />' + 
		             '</u:Browse>'
		                  
		//lInfo.logln("sonosSonosFavorites=" + action);

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else
			if (result.body != null) {
			var arrayLists = [];

			var data = unescapeXML(getXMLItem(result.body, 'Result'));
			//lInfo.logln('get Data: '+data);
			var aList = getXMLItemData(data, 'item');
			
			lInfo.logln("Favorites size:" + aList.length);

			for ( var iIndex = 0; iIndex < aList.length; iIndex++) {
				var sData = aList[iIndex];
				//lInfo.logln(' Item: ' + unescapeXML(sData));
				var sTitle = unescapeXML(getXMLItem(sData,"dc:title"));
				var sCall = getXMLItem(unescapeXML(sData),"res");
				var sDesc = unescapeXML(getXMLItem(sData,"r:description"));
				var sMeta = unescapeXML(getXMLItem(sData,"r:resMD"));

				var sID = "";
				var matches = sData.match(/id="(.*?)"/);
				if (matches != null) {
					sID = matches[1];
				}

				var bIsSingleTrack = (sData.indexOf("object.item.audioItem.musicTrack") > -1);

				if (sID != "") 
					if (sCall != "") {
						arrayLists.push({
							title : sTitle,
							//description : sDesc,
							listCall : sCall,
							metaData : sMeta,
							isSingleTrack : bIsSingleTrack,
							listID : sID
						});
						lInfo.logln(sTitle + " - " + sID + " - " + sCall);
					}
				
			}
			lPerf.logln('runtime upnpGetSonosFavorites '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
			return arrayLists;
		}
	} catch (e) {
		lInfo.logln("Error executing upnpGetSonosFavorites command " + e);
	}
	return null;
}

function upnpGetCurrentQueue(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		lInfo.logln("upnpGetCurrentQueue: " + szIpAddressRenderer);
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaServer/ContentDirectory/Control';

		var action = '<u:Browse xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">' + 
						'<ObjectID>Q:0</ObjectID>' + 
						'<BrowseFlag>BrowseDirectChildren</BrowseFlag>'	+ 
						'<Filter />' + 
						'<StartingIndex>0</StartingIndex>' + 
						'<RequestedCount>0</RequestedCount>' + 
						'<SortCriteria />' + 
					'</u:Browse>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);

		var arrayLists = [];
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				var data = unescapeXML(getXMLItem(result.body, 'Result'));
				
				var aList = getXMLItemData(data, 'item');
				lInfo.logln("size:" + aList.length);
	
				for ( var iIndex = 0; iIndex < aList.length; iIndex++) {
	
					var sData = aList[iIndex];	

					lInfo.logln('-------------------------------------\n' + sData);
					
					var sTitle = unescapeXML(getXMLItem(sData,"dc:title"));				
					var sID =  unescapeXML(getXMLItem(sData,"res"));
					var sAlbumUri = unescapeXML(getXMLItem(sData,"upnp:albumArtURI"));
					var sArtist = unescapeXML(getXMLItem(sData,"r:albumArtist"));
					if (sArtist=="")
						sArtist = unescapeXML(getXMLItem(sData,"upnp:album"));
					if (sArtist.indexOf('s:Body')>=0)
						sArtist = '';
					
					var nTrackPos = unescapeXML(getXMLItem(sData,"upnp:originalTrackNumber"));
					
					if (sID != "") {
						arrayLists.push({
							title : htmlUnescape(sTitle),
							playID : unescape(sID),
							// albumUri:unescape(sAlbumUri),
							//artist : htmlUnescape(sArtist),
							trackPos : nTrackPos
						});
					}
				}
			}
		lPerf.logln('runtime upnpGetCurrentQueue '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
		return arrayLists;

	} catch (e) {
		lInfo.logln("Error executing upnpGetCurrentQueue command " + e);
	}
	return null;
}

function upnpGetCurrentRadio(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetMediaInfo"';

		var h = new HTTP({
			'debug' : 0,
			'connectTimeout' : 200
		}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action =  '<u:GetMediaInfo xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
		                  '<InstanceID>0</InstanceID>' + 
		              '</u:GetMediaInfo>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				var Metadata = unescapeXML(getXMLItem(result.body, 'CurrentURIMetaData'));
				var sTitle = unescapeXML(getXMLItem(Metadata, 'dc:title'));
				var sUrl = unescapeXML(getXMLItem(result.body, 'CurrentURI'));
				var oReturn={};
				oReturn.url = sUrl;
				oReturn.Metadata = Metadata;
				oReturn.title = htmlUnescape(sTitle);
				oReturn.isRadio = true;
	
				lInfo.logln("Found radio: " + sUrl + " * " + sTitle);
				lPerf.logln('runtime upnpGetCurrentRadio '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return oReturn;
			}
	} catch (e) {
		lInfo.logln("Error executing upnpGetCurrentRadio command " + e);
	}
	return null;
}

function upnpGetCurrentTrack(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var posInfo = upnpGetPositionInfo(szIpAddressRenderer);
		if ((posInfo!=null) && (posInfo != "")) {
			var MetaData=getXMLItem(unescapeXML(posInfo),'TrackMetaData');
			lInfo.logln('Metadata:' + MetaData);
			var sUrl = unescapeXML(getXMLItem(MetaData,'res'));
			var sArtist = unescapeXML(getXMLItem(MetaData,'r:albumArtist'));
			if (sArtist=="")
				sArtist = unescapeXML(getXMLItem(MetaData,'upnp:album'));
			var sLength = getXMLAttribute(MetaData,'res','duration');
			var sTitle = unescapeXML(getXMLItem(MetaData, 'dc:title'));
			var oReturn;
			if (sLength!="") {
				oReturn={};
				oReturn.url = sUrl;
				oReturn.title = sTitle;
				oReturn.length = timeFromDuration(sLength);
				oReturn.artist = sArtist;
				oReturn.isRadio = false;
				oReturn.metaData=MetaData;
				lInfo.logln('Length: ' + sLength);
			} else {
				oReturn = upnpGetCurrentRadio(szIpAddressRenderer);
			}

			lInfo.logln("Found track " + oReturn.url + " * " + oReturn.title);
			lPerf.logln('runtime upnpGetCurrentTrack '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
			return oReturn;
		}
	} catch (e) {
		lInfo.logln("Error executing upnpGetCurrentTrack command " + e);
	}
	return null;
}

function upnpSetContentSrc(szIpAddressRenderer, szUpnpServerContent, sMetaData) {
	if (!isIPOnline(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action = '<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<CurrentURI>' + szUpnpServerContent + '</CurrentURI>' + 
						'<CurrentURIMetaData>' + sMetaData + '</CurrentURIMetaData>' + 
					 '</u:SetAVTransportURI>';
		lInfo.logln(' request :' + SOAPBodyStart + action + SOAPBodyEnd);
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null)
				lInfo.logln(result.body);
		lPerf.logln('runtime upnpSetContentSrc '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpSetContentSrc command " + e);
	}
	return null;
}

function upnpAddUriToQueue(szIpAddressRenderer, QueueID ,szUpnpServerContent, sMetaData) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-sonos-com:service:Queue:1#AddURI"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/Queue/Control';

		var action = '<u:AddURI xmlns:u="urn:schemas-sonos-com:service:Queue:1">' + 
						'<QueueID>'+QueueID+'</QueueID>' + 
						'<UpdateID>0</UpdateID>' + 
						'<EnqueuedURI>' + szUpnpServerContent + '</EnqueuedURI>';
		
		if (sMetaData==null)	
			action += '<EnqueuedURIMetaData />'; 
		else
			action +='<EnqueuedURIMetaData>' + encodeMetaDataUpnp(sMetaData) + '</EnqueuedURIMetaData>';
		action += '<DesiredFirstTrackNumberEnqueued>0</DesiredFirstTrackNumberEnqueued>' + 
						'<EnqueueAsNext>1</EnqueueAsNext>' + 						
					 '</u:AddURI>';
		lInfo.logln(' request :' + SOAPBodyStart + action + SOAPBodyEnd);
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null)
				lInfo.logln(result.body);
		lPerf.logln('runtime upnpSetContentSrc '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpSetContentSrc command " + e);
	}
	return null;
}

function upnpCreateQueue(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-sonos-com:service:Queue:1#CreateQueue"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/Queue/Control';
		var action = '<u:CreateQueue xmlns:u="urn:schemas-sonos-com:service:Queue:1">' + 
						'<QueueOwnerID>0</QueueOwnerID>' + 
						'<QueueOwnerContext>0</QueueOwnerContext>' + 
						'<QueuePolicy />' + 
					 '</u:CreateQueue>';
		lInfo.logln(' request :' + SOAPBodyStart + action + SOAPBodyEnd);
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				return parseInt(getXMLItem(result.body,'QueueID'),10);
			}
				
		return -1;
		lPerf.logln('runtime upnpSetContentSrc '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpSetContentSrc command " + e);
	}
	return null;
}

function upnpGetQueueURI(szIpAddressRenderer,queueID) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	var http_headers = [];
	http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
	http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"';

	var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);

	try {

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaServer/ContentDirectory/Control';
		lInfo.logln("URL " + url);

		var action = '<u:Browse xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">' + 
		                  '<ObjectID>Q:</ObjectID>' + 
		                  '<BrowseFlag>BrowseDirectChildren</BrowseFlag>' + 
		                  '<Filter />' + 
		                  '<StartingIndex>0</StartingIndex>' + 
		                  '<RequestedCount>0</RequestedCount>' + 
		                  '<SortCriteria />' + 
		             '</u:Browse>'
		                  
		lInfo.logln("upnpGetQueueURI=" + action);

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {

			var data = unescapeXML(getXMLItem(result.body, 'Result'));
			lInfo.logln('-------------------\n' + data);
			var aList = getXMLItemData(data, 'container');
			lInfo.logln("queues size:" + aList.length);

			for ( var iIndex = 0; iIndex < aList.length; iIndex++) {
				var sData = aList[iIndex];

				var sID = "";
				var matches = sData.match(/id="(.*?)"/);
				if (matches != null) {
					sID = matches[1];
				}
				if (sID=='Q:'+queueID) {
					lPerf.logln('runtime upnpGetQueueURI '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
					return getXMLItem(sData,"res");
				}
			}
			lPerf.logln('runtime upnpGetQueueURI '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
			
		}
	} catch (e) {
		lInfo.logln("Error executing upnpGetQueueURI command " + e);
	}
	return null;
}

function upnpSetRadio(szIpAddressRenderer, szUpnpServerContent, szTitle,szMeta) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	lInfo.logln('serverContent : ' + szUpnpServerContent);
	lInfo.logln('title : ' + szTitle);
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		szTitle = szTitle.replace('&', '&amp;');

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		
		
		var sMetaData = '&lt;DIDL-Lite xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:upnp="urn:schemas-upnp-org:metadata-1-0/upnp/" xmlns:r="urn:schemas-rinconnetworks-com:metadata-1-0/" xmlns="urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/"&gt;'
				+ ' &lt;item id="-1" parentID="-1" restricted="true"&gt;'
				+ ' &lt;dc:title&gt;'
				+ szTitle
				+ '&lt;/dc:title&gt;'
				+ ' &lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;'
				+ ' &lt;desc id="cdudn" nameSpace="urn:schemas-rinconnetworks-com:metadata-1-0/"&gt;SA_RINCON65031_&lt;/desc&gt;' + ' &lt;/item&gt;  &lt;/DIDL-Lite&gt;';
		if (szMeta!=null)
			sMetaData=szMeta;
		var action = '<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<CurrentURI>' + szUpnpServerContent + '</CurrentURI>' + 
						'<CurrentURIMetaData>' + sMetaData + '</CurrentURIMetaData>' + 
					'</u:SetAVTransportURI>';
		lInfo.logln('Value : ' + action);
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null)
				lInfo.logln(result.body);
		lPerf.logln('runtime upnpSetRadio '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpSetRadio command " + e);
	}
	return null;
}

function upnpClearQueue(szIpAddressRenderer,queueID) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-sonos-com:service:Queue:1#RemoveAllTracks"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/Queue/Control';
		lInfo.logln(url);

		var action = '<u:RemoveAllTracks xmlns:u="urn:schemas-sonos-com:service:Queue:1">' + 
						'<UpdateID>0</UpdateID>' + 
						'<QueueID>'+queueID+'</QueueID>' + 
					'</u:RemoveAllTracks>';

		var result= h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

		lPerf.logln('runtime upnpClearQueue '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpClearQueue command " + e);
	}
	return null;
}

function upnpLoadPlaylist(szIpAddressRenderer, szPlaylist, sMetaData) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#AddURIToQueue"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';


		var action = '<u:AddURIToQueue xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<EnqueuedURI>' + szPlaylist + '</EnqueuedURI>';

		if (sMetaData == null)
			action += '<EnqueuedURIMetaData />';
		else
			action += '<EnqueuedURIMetaData>' + sMetaData + '</EnqueuedURIMetaData>';
		
		action += 	'<DesiredFirstTrackNumberEnqueued>0</DesiredFirstTrackNumberEnqueued>' + 
					'<EnqueueAsNext>1</EnqueueAsNext>' + 
				'</u:AddURIToQueue>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		var sReturn = "";
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				sReturn = result.body;
				lInfo.logln("upnpLoadPlaylist=" + result.body);
			}
		lPerf.logln('runtime upnpLoadPlaylist '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
		return sReturn;
	} catch (e) {
		lWarn.logln("Error executing upnpLoadPlaylist command " + e);
	}
	return "";
}

function upnpSeek(szIpAddressRenderer, bByTrack, seekValue) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Seek"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var sUnit = 'TRACK_NR';
		if (!bByTrack)
			sUnit = 'REL_TIME';

		var action = '<u:Seek xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<Unit>' + sUnit + '</Unit>' + 
						'<Target>' + seekValue + '</Target>' + 
					'</u:Seek>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null)
				lInfo.logln(result.body);
		lPerf.logln('runtime upnpSeek '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpSeek command " + e);
	}
	return null;
}

function upnpGetMute(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:GroupRenderingControl:1#GetGroupMute"';

		var h = new HTTP( {'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/GroupRenderingControl/Control';

		var action = '<u:GetGroupMute xmlns:u="urn:schemas-upnp-org:service:GroupRenderingControl:1">' + 
						'<InstanceID>0</InstanceID>' + 
					'</u:GetGroupMute>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);

		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				lInfo.logln(result.body);
				var sMute = getXMLItem(result.body,'CurrentMute');
				if (sMute != "")
					if (sMute == "1") {
						lPerf.logln('runtime upnpGetMute '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
						return true;
					}
			}
	} catch (e) {
		lInfo.logln("Error executing upnpSetMute command " + e);
	}
	lPerf.logln('runtime upnpGetMute '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return false;
}

function upnpSetMute(szIpAddressRenderer, bMute) {	
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:GroupRenderingControl:1#SetGroupMute"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/GroupRenderingControl/Control';

		var nMute = 0;
		if (bMute)
			nMute = 1;

		var action = '<u:SetGroupMute xmlns:u="urn:schemas-upnp-org:service:GroupRenderingControl:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<DesiredMute>' + nMute + '</DesiredMute>' + 
					'</u:SetGroupMute>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);

		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null)
				lInfo.logln(result.body);
		lPerf.logln('runtime upnpSetMute '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpSetMute command " + e);
	}
	return null;
}

function upnpSetVolume(szIpAddressRenderer, nVolume) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	lInfo.logln("upnpSetVolume " + szIpAddressRenderer + " to " + nVolume);
	try {
		if (nVolume != null) {
			var http_headers = [];
			http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
			http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#SetVolume"';

			var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);
			h.reset();

			var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/RenderingControl/Control';

			var action = '<u:SetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">' + 
							'<InstanceID>0</InstanceID>' + 
							'<Channel>Master</Channel>' + 
							'<DesiredVolume>' + nVolume + '</DesiredVolume>' + 
						'</u:SetVolume>';

			var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);

			if (result==null)
				signalDisabledPlayer(szIpAddressRenderer);
			else if (result.body != null)
					lInfo.logln(result.body);
			lPerf.logln('runtime upnpSetVolume '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
		}
	} catch (e) {
		lInfo.logln("Error executing upnpSetVolume command " + e);
	}
	return null;
}

function upnpGetTransportInfo(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetTransportInfo"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action = '<u:GetTransportInfo xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
					'</u:GetTransportInfo>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				lPerf.logln('runtime upnpGetTransportInfo '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return getXMLItem(result.body, 'CurrentTransportState');
			}
	} catch (e) {
		lWarn.logln("Error executing upnpGetTransportInfo command " + e);
	}
	return "";
}

function upnpGetPositionInfo(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetPositionInfo"';//

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action = '<u:GetPositionInfo xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
					'</u:GetPositionInfo>';

		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				lPerf.logln('runtime upnpGetPositionInfo '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return result.body;
			}
	} catch (e) {
		lWarn.logln("Error executing upnpGetPositionInfo command " + e);
	}
	lPerf.logln('runtime upnpGetPositionInfo '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return "";
}

function upnpGetMediaInfo(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetMediaInfo"';//

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();
		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action = '<u:GetMediaInfo xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
					'</u:GetMediaInfo>';
		result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null){
				lPerf.logln('runtime upnpGetMediaInfo '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return result.body;
			}
	} catch (e) {
		lWarn.logln("Error executing upnpGetMediaInfo command " + e);
	}
	lPerf.logln('runtime upnpGetMediaInfo '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}

function upnpGetVolume(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#GetVolume"';//

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();
		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/RenderingControl/Control';

		var action = '<u:GetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<Channel>Master</Channel>' + 
					'</u:GetVolume>';
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
			lPerf.logln('runtime upnpGetVolume '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return getXMLItem(result.body, 'CurrentVolume');
			}
	} catch (e) {
		lWarn.logln("Error executing upnpGetVolume command " + e);
	}
	lPerf.logln('runtime upnpGetVolume '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}

/*
 * sModeName: NORMAL, REPEAT_ALL, SHUFFLE_NOREPEAT, SHUFFLE
 */
function upnpSetPlayMode(szIpAddressRenderer, sModeName) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetPlayMode"';//
		lInfo.logln('set mode to ' + sModeName);
		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();
		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action = '<u:SetPlayMode xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<NewPlayMode>' + sModeName + '</NewPlayMode>' + 
					'</u:SetPlayMode>';
		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

		lPerf.logln('runtime upnpSetPlayMode '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lWarn.logln("Error executing upnpSetPlayMode command " + e);
	}
	return null;
}

function upnpGetPlayMode(szIpAddressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetTransportSettings"';//

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();
		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';

		var action = '<u:GetTransportSettings xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
					'</u:GetTransportSettings>';
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				lPerf.logln('runtime upnpGetPlayMode '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return getXMLItem(result.body, 'PlayMode');
			}
	} catch (e) {
		lWarn.logln("Error executing upnpSetPlayMode command " + e);
	}
	lPerf.logln('runtime upnpGetPlayMode '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return "";
}

function upnpGetSonosGroups(szIpAddressRenderer,fSkipOnlineTest) {
	if ((fSkipOnlineTest==null) || (!fSkipOnlineTest))
		if (!isIPOnline(szIpAddressRenderer))
			return null;
	var oStartDate=new Date().getTime();

	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ZoneGroupTopology:1#GetZoneGroupState"';//

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);
		h.reset();
		var url = 'http://' + szIpAddressRenderer + ':1400/ZoneGroupTopology/Control';

		var action = '<u:GetZoneGroupState xmlns:u="urn:schemas-upnp-org:service:ZoneGroupTopology:1" />';
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		var arrayGroups = [];
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
				var sGroup = unescapeXML(getXMLItem(result.body,'ZoneGroupState'));
				var aGroups = getXMLItemData(sGroup, 'ZoneGroup');
				if (aGroups.length > 0) {
					for ( var iIndex = 0; iIndex < aGroups.length; iIndex++) {
						var object={
								id:getXMLAttribute(aGroups[iIndex],'ZoneGroup','ID'),
								coordinator:getXMLAttribute(aGroups[iIndex],'ZoneGroup','Coordinator'),
								member:[]};

						var memberGroups = getXMLItemData(aGroups[iIndex], 'ZoneGroupMember');
						
						for (var jIndex=0;jIndex<memberGroups.length;jIndex++) {
							var deviceip=getXMLAttribute(memberGroups[jIndex],'ZoneGroupMember','Location');
							var invisible=(getXMLAttribute(memberGroups[jIndex],'ZoneGroupMember','Invisible')=='1');
							var ip=deviceip.substr(7);
							ip=ip.substr(0,ip.indexOf(':1400'));
							var oMember={
								id:getXMLAttribute(memberGroups[jIndex],'ZoneGroupMember','UUID'),
								ip:ip,
								deviceXML:deviceip,
								invisible:invisible,
								name:getXMLAttribute(memberGroups[jIndex],'ZoneGroupMember','ZoneName')
							}							
							object.member.push(oMember);
						}	
						arrayGroups.push(object);
					}
				}
				lPerf.logln('runtime upnpGetSonosGroups '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return arrayGroups;
			}			
	} catch (e) {
		lWarn.logln("Error executing upnpGetSonosGroups command " + e);
	}
	lPerf.logln('runtime upnpGetSonosGroups '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}

function upnpGetSonosGroupID(szIpAddressRenderer, sDeviceID) {
	if (!isIPOnline(szIpAddressRenderer))
		return null;	
	var oArray=upnpGetSonosGroups(szIpAddressRenderer);
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		for (var jIndex=0;jIndex<oArray[iIndex].member.length;jIndex++) {
			if (oArray[iIndex].member[jIndex]==sDeviceID)
				return oArray[iIndex].id;
		}
	}
	return null;
}

function upnpSaveQueue(szIpAddressRenderer, sTitle) {	
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SaveQueue"';//

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();
		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		var action = '<u:SaveQueue xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>' + 
						'<Title>' + sTitle + '</Title>' + 
						'<ObjectID />' + 
					' </u:SaveQueue>';
		var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		var sQueueID = "";
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else if (result.body != null) {
			var sString=result.body.substr(result.body.indexOf('<AssignedObjectID>')+18)
			sQueueID=sString.substr(0,sString.indexOf('</AssignedObjectID>'));			
		}
		lPerf.logln('runtime upnpSaveQueue '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
		return sQueueID;
	} catch (e) {
		lWarn.logln("Error executing upnpSaveQueue command " + e);
	}
	lPerf.logln('runtime upnpSaveQueue '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return "";
}

function upnpDeleteQueueFromList(szIpAddressRenderer, sQueueID) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#DestroyObject"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaServer/ContentDirectory/Control';
		lInfo.logln("URL " + url);

		var action = '<u:DestroyObject xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">' + 
						'<ObjectID>' + sQueueID + '</ObjectID>' + 
					'</u:DestroyObject>';

		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

	} catch (e) {
		lInfo.logln("Error executing upnpDeleteQueueFromList command " + e);
	}
	lPerf.logln('runtime upnpDeleteQueueFromList '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}

function upnpSetPlayerAsStandAloneGroup(szIpAddressRenderer) {
	if (!isIPOnline(szIpAddressRenderer))
		return null;
	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#BecomeCoordinatorOfStandaloneGroup"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		lInfo.logln("URL " + url);

		var action = '<u:BecomeCoordinatorOfStandaloneGroup xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' + 
						'<InstanceID>0</InstanceID>'
					+ '</u:BecomeCoordinatorOfStandaloneGroup>';

		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

	} catch (e) {
		lInfo.logln("Error executing upnpSetPlayerAsStandAloneGroup command " + e);
	}
	lPerf.logln('runtime upnpSetPlayerAsStandAloneGroup '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}

function upnpStartAutoPlay(szIpAddressRenderer,sURI,metaData,volume) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#StartAutoplay"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/AVTransport/Control';
		lInfo.logln("URL " + url);

		var action = '<u:StartAutoplay xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">' +
	         			'<InstanceID>0</InstanceID>' +
	         			'<ProgramURI>'+sURI+'</ProgramURI>' + 
	         			'<ProgramMetaData>'+metaData+'</ProgramMetaData>' + 
	         			'<Volume>'+volume+'</Volume>' + 
	         			'<IncludeLinkedZones>1</IncludeLinkedZones>' +
	         			'<ResetVolumeAfter>1</ResetVolumeAfter>' +
	         		'</u:StartAutoplay>';

		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

	} catch (e) {
		lInfo.logln("Error executing upnpStartAutoPlay command " + e);
	}
	lPerf.logln('runtime upnpStartAutoPlay '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}

function upnpGetSonosPlaylists(szIpAddressRenderers) {
	for ( var kIndex = 0; kIndex < szIpAddressRenderers.length; kIndex++) {
		if (!isIPOnline(szIpAddressRenderers[kIndex]))
			return null;
	}
	var oStartDate=new Date().getTime();
	var http_headers = [];
	http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
	http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"';

	var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);

	for ( var kIndex = 0; kIndex < szIpAddressRenderers.length; kIndex++) {
		try {
			h.reset();
			var szIpAddressRenderer = szIpAddressRenderers[kIndex];

			var url = 'http://' + szIpAddressRenderer + ':1400/MediaServer/ContentDirectory/Control';
			lInfo.logln("URL " + url);

			var action = '<u:Browse xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">' + 
							'<ObjectID>SQ:</ObjectID>' + 
							'<BrowseFlag>BrowseDirectChildren</BrowseFlag>' + 
							'<Filter />' + 
							'<StartingIndex>0</StartingIndex>' + 
							'<RequestedCount>0</RequestedCount>' + 
							'<SortCriteria />' + 
						  '</u:Browse>';
			var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
			var arrayLists=[];
			
			if (result==null)
				signalDisabledPlayer(szIpAddressRenderer);
			else if (result.body != null) {
					var data = unescapeXML(getXMLItem(result.body, 'Result'));
					var aList = getXMLItemData(data, 'container');
					for ( var iIndex = 0; iIndex < aList.length; iIndex++) {
	
						var sData = aList[iIndex];
	
						var sTitle = unescapeXML(getXMLItem(sData,"dc:title"));
						var sCall = unescapeXML(getXMLItem(sData,"res"));
						var sID = "";
						
						var matches = sData.match(/id="(.*?)"/);
						if (matches != null) {
							sID = matches[1];
						}
						var sMetaData='<DIDL-Lite xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:upnp="urn:schemas-upnp-org:metadata-1-0/upnp/" xmlns:r="urn:schemas-rinconnetworks-com:metadata-1-0/" xmlns="urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/"><item id="'+
							sID + '" parentID="SQ:" restricted="true"><dc:title>'+
							sTitle + '</dc:title><upnp:class>object.container.playlistContainer</upnp:class><desc id="cdudn" nameSpace="urn:schemas-rinconnetworks-com:metadata-1-0/">RINCON_AssociatedZPUDN</desc></item></DIDL-Lite>'
						if (sID != "" && sCall != "") {
							arrayLists.push({
								title : sTitle,
								listID : sID,
								listCall : sCall,
								metaData : sMetaData
								
							});
							lInfo.logln(sTitle + " - " + sID + " - " + sCall);
						}
	
						lInfo.logln("sonosPlayListAction END");
					}
					lPerf.logln('runtime upnpGetSonosPlaylist '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
					return arrayLists;
				}
		} catch (e) {
			lInfo.logln("Error executing upnpGetSonosPlaylist command on player " + szIpAddressRenderers[iIndex] + ' : ' + e);
		}
	}
	return null;
}

function upnpGetSonosPlaylistsXML(szIpAddressRenderers) {
	for ( var kIndex = 0; kIndex < szIpAddressRenderers.length; kIndex++) {
		if (!isIPOnline(szIpAddressRenderers[kIndex]))
			return null;
	}
	var oStartDate=new Date().getTime();
	var http_headers = [];
	http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
	http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"';

	var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);

	for ( var kIndex = 0; kIndex < szIpAddressRenderers.length; kIndex++) {
		try {
			h.reset();
			var szIpAddressRenderer = szIpAddressRenderers[kIndex];

			var url = 'http://' + szIpAddressRenderer + ':1400/MediaServer/ContentDirectory/Control';
			lInfo.logln("URL " + url);

			var action = '<u:Browse xmlns:u="urn:schemas-upnp-org:service:ContentDirectory:1">' + 
							'<ObjectID>SQ:</ObjectID>' + 
							'<BrowseFlag>BrowseDirectChildren</BrowseFlag>' + 
							'<Filter />' + 
							'<StartingIndex>0</StartingIndex>' + 
							'<RequestedCount>0</RequestedCount>' + 
							'<SortCriteria />' + 
						  '</u:Browse>';
			var result = h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
			var arrayLists=[];
			
			if (result==null)
				signalDisabledPlayer(szIpAddressRenderer);
			else if (result.body != null) {
				lInfo.logln('reg ' + result.body);
				var oXML=new XML("" + result.body);
				var didlXML=new XML("" + oXML..Result)
				var containerListe=didlXML;
				lInfo.logln('das ergebnis: ' +didlXML + ' d '+containerListe[2]);
				for (var iIndex=0;iIndex<containerListe.length();iIndex++) {
					lInfo.logln('Substruct: ' + containerListe[iIndex]);
				}
				/*
					var data = unescapeXML(getXMLItem(result.body, 'Result'));
					var aList = getXMLItemData(data, 'container');
					for ( var iIndex = 0; iIndex < aList.length; iIndex++) {
	
						var sData = aList[iIndex];
	
						var sTitle = unescapeXML(getXMLItem(sData,"dc:title"));
						var sCall = unescapeXML(getXMLItem(sData,"res"));
						var sID = "";
						
						var matches = sData.match(/id="(.*?)"/);
						if (matches != null) {
							sID = matches[1];
						}
						var sMetaData='<DIDL-Lite xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:upnp="urn:schemas-upnp-org:metadata-1-0/upnp/" xmlns:r="urn:schemas-rinconnetworks-com:metadata-1-0/" xmlns="urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/"><item id="'+
							sID + '" parentID="SQ:" restricted="true"><dc:title>'+
							sTitle + '</dc:title><upnp:class>object.container.playlistContainer</upnp:class><desc id="cdudn" nameSpace="urn:schemas-rinconnetworks-com:metadata-1-0/">RINCON_AssociatedZPUDN</desc></item></DIDL-Lite>'
						if (sID != "" && sCall != "") {
							arrayLists.push({
								title : sTitle,
								listID : sID,
								listCall : sCall,
								metaData : sMetaData
								
							});
							lInfo.logln(sTitle + " - " + sID + " - " + sCall);
						}
	
						lInfo.logln("sonosPlayListAction END");
					}
					lPerf.logln('runtime upnpGetSonosPlaylist '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
					return arrayLists;
					*/
					lPerf.logln('runtime upnpGetSonosPlaylistXML '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				}
		} catch (e) {
			lInfo.logln("Error executing upnpGetSonosPlaylist command on player " + szIpAddressRenderers[iIndex] + ' : ' + e);
		}
	}
	return null;
}


function upnpCreateSonosQueue(szIpAdressRenderer) {
	if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
		return null;

	var oStartDate=new Date().getTime();
	try {
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-sonos-com:service:Queue:1#CreateQueue"';

		var h = new HTTP({'debug' : 0,'connectTimeout' : 200}, http_headers);

		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/Queue/Control';
		lInfo.logln("URL " + url);

		var action = '<u:CreateQueue xmlns:u="urn:schemas-sonos-com:service:Queue:1">' +
	         			'<QueueOwnerID>0</QueueOwnerID>' +
	         			'<QueueOwnerContext>0</QueueOwnerContext>' + 
	         			'<QueuePolicy />' + 
	         		'</u:CreateQueue>';

		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);
		else {
			if (result.body!=null) {
				lPerf.logln('runtime upnpCreateSonosQueue '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
				return getXMLItem(result.body, 'QueueID');
			}
		}
	} catch (e) {
		lInfo.logln("Error executing upnpStartAutoPlay command " + e);
	}
	lPerf.logln('runtime upnpCreateSonosQueue '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	return null;
}
 